<!DOCTYPE html>
    <html>
    <head>
        <meta charset="UTF-8">
        <title>Graph Theory Project</title>
        
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/gh/Microsoft/vscode/extensions/markdown-language-features/media/markdown.css">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/gh/Microsoft/vscode/extensions/markdown-language-features/media/highlight.css">
        
        <style>
.task-list-item { list-style-type: none; } .task-list-item-checkbox { margin-left: -20px; vertical-align: middle; }
</style>
        <style>
            body {
                font-family: -apple-system, BlinkMacSystemFont, 'Segoe WPC', 'Segoe UI', 'Ubuntu', 'Droid Sans', sans-serif;
                font-size: 14px;
                line-height: 1.6;
            }
        </style>
        
        
    </head>
    <body class="vscode-light">
        <h1 id="graph-theory-project">Graph Theory Project</h1>
<p>Quentin ROSTALSKI / Matthias URANGA
<br><br></p>
<h2 id="index">Index</h2>
<ul>
<li><a href="#graph-theory-project">Graph Theory Project</a>
<ul>
<li><a href="#index">Index</a></li>
<li><a href="#subject">Subject</a></li>
<li><a href="#objective">Objective</a></li>
<li><a href="#specifications">Specifications</a></li>
<li><a href="#our-choice">Our choice</a></li>
<li><a href="#work-organisation">Work organisation</a></li>
<li><a href="#user-manual">User Manual</a></li>
<li><a href="#files">Files</a>
<ul>
<li><a href="#python-files">Python files</a>
<ul>
<li><a href="#create-json-file">Create json file</a></li>
<li><a href="#load-json-file">Load json file</a></li>
<li><a href="#user-menu">User menu</a></li>
</ul>
</li>
<li><a href="#example-json-files">Example JSON files</a>
<ul>
<li><a href="#students-json">Students JSON</a></li>
<li><a href="#schools-json">Schools JSON</a></li>
<li><a href="#result-of-stable-mariage-json">Result of stable mariage JSON</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h2 id="subject">Subject</h2>
<p>Some students want to choose schools for next year. Each student ranked the schools and each school ranked each student. The goal is to find a combination that would be as stable as possible according to each student's preferences.
<br><br></p>
<h2 id="objective">Objective</h2>
<p>The objective of the project is to realize a stable marriage algorithm between students and schools in the language of our choice.
<br><br></p>
<h2 id="specifications">Specifications</h2>
<ul>
<li>Students and schools and their choices must be specified in files.</li>
<li>Students or Schools can serenade</li>
<li>There is a defined number of place in every school</li>
<li>For a stable mariage, we need the same numbers of students than the total numbers of place in schools
<br><br></li>
</ul>
<h2 id="our-choice">Our choice</h2>
<p>We choose to developp the algorithm in <strong>Python</strong> which is very useful for ease of programming as well as ease of understanding, the source file and the result of the algorithm will be in <strong>json</strong> because it's a widely used format nowadays and it's very easy to understand and couple it with Python. The project is divided in 3 parts :</p>
<ul>
<li>A programm to create the <strong>json</strong> file randomly.</li>
<li>A programm to read the <strong>json</strong> file.</li>
<li>A programm used for the user menu.</li>
<li>A programm to apply the algorithm. The algorithm is also divided in multiples parts :
<ul>
<li>A function <em>makeMatches</em>, which allows you to assign the student to the first school on your preferred school list by removing that school from your list after assigning the student.</li>
<li>A function <em>checkMatches</em>, which makes it possible to see for each school whether the number of students applying per round is greater than their capacity. If this is the case then the school will sort the students according to its preference list and will eject the excess students.
<br><br></li>
</ul>
</li>
</ul>
<h2 id="work-organisation">Work organisation</h2>
<p>We decided to work with GitLab in order to be able to work in parallel and to be able to control and version our files.</p>
<h2 id="user-manual">User Manual</h2>
<p>To start the program you have to execute the <strong><a href="http://main.py">main.py</a></strong> file. Once launched you will come across the following window :</p>
<p>From here you can choose who is going to serenade (St)udents or (Sc)hools.</p>
<p>And then, choose the number of students and the number of schools (both must been even number).</p>
<p>Finally, you'll find the result in the file <strong>result.json</strong>.
<br><br></p>
<h2 id="files">Files</h2>
<h3 id="python-files">Python files</h3>
<h4 id="create-json-file">Create json file</h4>
<pre><code class="language-python"><div><span class="hljs-keyword">import</span> random
<span class="hljs-keyword">import</span> json

<span class="hljs-function"><span class="hljs-keyword">def</span> <span class="hljs-title">init_Students_Schools</span><span class="hljs-params">()</span>:</span>
    <span class="hljs-comment"># Asking the user how many students he wants</span>
    nbStudents = int(input(<span class="hljs-string">"Number of Students : "</span>))

    <span class="hljs-comment"># Asking the user how many schools he wants</span>
    nbSchools = int(input(<span class="hljs-string">"Number of Schools : "</span>))
    <span class="hljs-keyword">return</span> [nbStudents,nbSchools]


<span class="hljs-function"><span class="hljs-keyword">def</span> <span class="hljs-title">createSchools</span><span class="hljs-params">(list_init)</span>:</span>
    <span class="hljs-comment"># Init the random students list</span>
    random_student_list = []
    <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> range(list_init[<span class="hljs-number">0</span>]):
        random_student_list.append(i)
    
    <span class="hljs-comment"># Init the random schools list</span>
    random_school_list = []
    <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> range(list_init[<span class="hljs-number">1</span>]):
        random_school_list.append(i)

    <span class="hljs-comment"># Init Students and their choices</span>
    students_dict = {}
    <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> range(list_init[<span class="hljs-number">0</span>]):
        choice = []
        random.shuffle(random_school_list)
        <span class="hljs-keyword">for</span> j <span class="hljs-keyword">in</span> range(len(random_school_list)):
            choice.append(<span class="hljs-string">"school"</span> + str(random_school_list[j]))
        students_dict[<span class="hljs-string">"stud"</span> + str(i)] = choice
    
    <span class="hljs-comment"># Init Schools and their choices</span>
    schools_dict = {}
    <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> range(list_init[<span class="hljs-number">1</span>]):
        choice = []
        random.shuffle(random_student_list)
        <span class="hljs-keyword">for</span> j <span class="hljs-keyword">in</span> range(len(random_student_list)):
            choice.append(<span class="hljs-string">"stud"</span> + str(random_student_list[j]))
        schools_dict[<span class="hljs-string">"school"</span> + str(i)] = choice

    <span class="hljs-comment"># Write students and them choices in json file</span>
    <span class="hljs-keyword">with</span> open(<span class="hljs-string">"student.json"</span>,<span class="hljs-string">"w"</span>) <span class="hljs-keyword">as</span> file:
        file.write(json.dumps(students_dict, indent=<span class="hljs-number">4</span>))

    <span class="hljs-comment"># Write schools and them choices in json file</span>
    <span class="hljs-keyword">with</span> open(<span class="hljs-string">"school.json"</span>,<span class="hljs-string">"w"</span>) <span class="hljs-keyword">as</span> file:
        file.write(json.dumps(schools_dict, indent=<span class="hljs-number">4</span>))
</div></code></pre>
<br>
<h4 id="load-json-file">Load json file</h4>
<pre><code class="language-python"><div><span class="hljs-keyword">import</span> json

<span class="hljs-function"><span class="hljs-keyword">def</span> <span class="hljs-title">load</span><span class="hljs-params">()</span>:</span>
    <span class="hljs-comment"># Open the school json file and transform json type into dict type</span>
    <span class="hljs-keyword">with</span> open(<span class="hljs-string">"school.json"</span>) <span class="hljs-keyword">as</span> file:
        school_dict = json.loads(file.read())

    <span class="hljs-comment"># Open the student json file and transform json type into dict type</span>
    <span class="hljs-keyword">with</span> open(<span class="hljs-string">"student.json"</span>) <span class="hljs-keyword">as</span> file:
        student_dict = json.loads(file.read())

    <span class="hljs-keyword">return</span> [student_dict, school_dict]
</div></code></pre>
<br>
<h4 id="user-menu">User menu</h4>
<br>
<h3 id="example-json-files">Example JSON files</h3>
<h4 id="students-json">Students JSON</h4>
<p>Every <strong>keys</strong> of the JSON file are students and the <strong>values</strong> are a list of ranking schools for every students.</p>
<pre><code class="language-json"><div>{
    <span class="hljs-attr">"stud0"</span>: [
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school2"</span>
    ],
    <span class="hljs-attr">"stud1"</span>: [
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school1"</span>
    ],
    <span class="hljs-attr">"stud2"</span>: [
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school1"</span>
    ],
    <span class="hljs-attr">"stud3"</span>: [
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school3"</span>
    ],
    <span class="hljs-attr">"stud4"</span>: [
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school2"</span>
    ],
    <span class="hljs-attr">"stud5"</span>: [
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school1"</span>
    ],
    <span class="hljs-attr">"stud6"</span>: [
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school2"</span>
    ],
    <span class="hljs-attr">"stud7"</span>: [
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school3"</span>
    ],
    <span class="hljs-attr">"stud8"</span>: [
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school1"</span>
    ],
    <span class="hljs-attr">"stud9"</span>: [
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school3"</span>
    ],
    <span class="hljs-attr">"stud10"</span>: [
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school3"</span>,
        <span class="hljs-string">"school2"</span>
    ],
    <span class="hljs-attr">"stud11"</span>: [
        <span class="hljs-string">"school0"</span>,
        <span class="hljs-string">"school2"</span>,
        <span class="hljs-string">"school1"</span>,
        <span class="hljs-string">"school3"</span>
    ]
}
</div></code></pre>
<br>
<h4 id="schools-json">Schools JSON</h4>
<p>Every <strong>keys</strong> of the JSON file are schools and the <strong>values</strong> are a list of ranking students for every schools.</p>
<pre><code class="language-json"><div>{
    <span class="hljs-attr">"school0"</span>: [
        <span class="hljs-string">"stud1"</span>,
        <span class="hljs-string">"stud5"</span>,
        <span class="hljs-string">"stud11"</span>,
        <span class="hljs-string">"stud4"</span>,
        <span class="hljs-string">"stud7"</span>,
        <span class="hljs-string">"stud8"</span>,
        <span class="hljs-string">"stud3"</span>,
        <span class="hljs-string">"stud0"</span>,
        <span class="hljs-string">"stud2"</span>,
        <span class="hljs-string">"stud10"</span>,
        <span class="hljs-string">"stud6"</span>,
        <span class="hljs-string">"stud9"</span>
    ],
    <span class="hljs-attr">"school1"</span>: [
        <span class="hljs-string">"stud8"</span>,
        <span class="hljs-string">"stud0"</span>,
        <span class="hljs-string">"stud10"</span>,
        <span class="hljs-string">"stud1"</span>,
        <span class="hljs-string">"stud6"</span>,
        <span class="hljs-string">"stud11"</span>,
        <span class="hljs-string">"stud7"</span>,
        <span class="hljs-string">"stud3"</span>,
        <span class="hljs-string">"stud9"</span>,
        <span class="hljs-string">"stud2"</span>,
        <span class="hljs-string">"stud4"</span>,
        <span class="hljs-string">"stud5"</span>
    ],
    <span class="hljs-attr">"school2"</span>: [
        <span class="hljs-string">"stud1"</span>,
        <span class="hljs-string">"stud6"</span>,
        <span class="hljs-string">"stud9"</span>,
        <span class="hljs-string">"stud10"</span>,
        <span class="hljs-string">"stud8"</span>,
        <span class="hljs-string">"stud7"</span>,
        <span class="hljs-string">"stud3"</span>,
        <span class="hljs-string">"stud11"</span>,
        <span class="hljs-string">"stud4"</span>,
        <span class="hljs-string">"stud5"</span>,
        <span class="hljs-string">"stud2"</span>,
        <span class="hljs-string">"stud0"</span>
    ],
    <span class="hljs-attr">"school3"</span>: [
        <span class="hljs-string">"stud7"</span>,
        <span class="hljs-string">"stud8"</span>,
        <span class="hljs-string">"stud2"</span>,
        <span class="hljs-string">"stud5"</span>,
        <span class="hljs-string">"stud3"</span>,
        <span class="hljs-string">"stud6"</span>,
        <span class="hljs-string">"stud1"</span>,
        <span class="hljs-string">"stud10"</span>,
        <span class="hljs-string">"stud11"</span>,
        <span class="hljs-string">"stud4"</span>,
        <span class="hljs-string">"stud9"</span>,
        <span class="hljs-string">"stud0"</span>
    ]
}
</div></code></pre>
<br>
<h4 id="result-of-stable-mariage-json">Result of stable mariage JSON</h4>
<p>Every <strong>keys</strong> of the JSON file are schools and the <strong>values</strong> are a list of the choosen students for every schools.</p>
<pre><code class="language-json"><div>{
    <span class="hljs-attr">"school0"</span>: [
        <span class="hljs-string">"stud1"</span>,
        <span class="hljs-string">"stud11"</span>,
        <span class="hljs-string">"stud7"</span>
    ],
    <span class="hljs-attr">"school1"</span>: [
        <span class="hljs-string">"stud3"</span>,
        <span class="hljs-string">"stud10"</span>,
        <span class="hljs-string">"stud0"</span>
    ],
    <span class="hljs-attr">"school2"</span>: [
        <span class="hljs-string">"stud2"</span>,
        <span class="hljs-string">"stud8"</span>,
        <span class="hljs-string">"stud9"</span>
    ],
    <span class="hljs-attr">"school3"</span>: [
        <span class="hljs-string">"stud5"</span>,
        <span class="hljs-string">"stud6"</span>,
        <span class="hljs-string">"stud4"</span>
    ]
}
</div></code></pre>

    </body>
    </html>